'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classnames = require('classnames');
var Typography = require('@highlight-ui/typography');
var utilsCommons = require('@highlight-ui/utils-commons');
var Icon = require('@highlight-ui/icon');
var Tooltip = require('@highlight-ui/tooltip');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
var Typography__default = /*#__PURE__*/_interopDefaultLegacy(Typography);
var Icon__default = /*#__PURE__*/_interopDefaultLegacy(Icon);
var Tooltip__default = /*#__PURE__*/_interopDefaultLegacy(Tooltip);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var styles$6 = {"horizontalFormField":"HorizontalFormField-module__fVdGP8co__v1-0-3","tooltipIcon":"HorizontalFormField-module__1NdwBwBB__v1-0-3","head":"HorizontalFormField-module__2-Xz3vuF__v1-0-3","field":"HorizontalFormField-module__37le0oUn__v1-0-3","validations":"HorizontalFormField-module__3cWl90i4__v1-0-3","tooltipContent":"HorizontalFormField-module__2NMGEC18__v1-0-3"};

var styles$5 = {"labelContainer":"styles-module__w84P_0so__v1-0-3","label":"styles-module__3nI9XCrs__v1-0-3","labelTooltipIcon":"styles-module__3K-HIjuG__v1-0-3"};

var Label = function (_a) {
    var className = _a.className, label = _a.label, tooltipContent = _a.tooltipContent, tooltipMouseOutDelay = _a.tooltipMouseOutDelay, tooltipClassName = _a.tooltipClassName, htmlFor = _a.htmlFor;
    return (React__default['default'].createElement("div", { className: classnames__default['default'](styles$5.labelContainer, className) },
        React__default['default'].createElement(Typography__default['default'], __assign({ className: styles$5.label, variant: "subtitle-2", component: "label" }, (htmlFor ? { htmlFor: htmlFor } : {})), label),
        tooltipContent && (React__default['default'].createElement(Tooltip__default['default'], { content: tooltipContent, mouseOutDelay: tooltipMouseOutDelay, metadata: { testId: 'form-field-label-tooltip-icon' }, interactive: true },
            React__default['default'].createElement("span", null,
                React__default['default'].createElement(Icon__default['default'], { className: classnames__default['default'](styles$5.labelTooltipIcon, tooltipClassName), name: "info-circle", color: "neutral-gray-darker", type: "solid", size: 14 }))))));
};

var styles$4 = {"validations":"Validations-module__RYfMjzVM__v1-0-3","validation":"Validations-module__2gUpr8kH__v1-0-3"};

var styles$3 = {"validationContainer":"styles-module__Lvz4m8hY__v1-0-3","validationStatusIcon":"styles-module__1LNuNqbX__v1-0-3","validationMessage":"styles-module__1VarQcki__v1-0-3"};

var validationStatusesIconProps = {
    validating: {
        name: 'spinner-third',
        color: 'primary-brand-accent',
        spin: true,
    },
    valid: { name: 'check-circle', color: 'ui-success' },
    invalid: { name: 'exclamation-circle', color: 'ui-danger' },
    warning: { name: 'exclamation-triangle', color: 'ui-warning' },
};
var ValidationMessage = function (_a) {
    var className = _a.className, message = _a.message, status = _a.status, metadata = _a.metadata;
    var validationStatusIconProps = validationStatusesIconProps[status];
    return (React__default['default'].createElement("span", __assign({ className: classnames__default['default'](styles$3.validationContainer, className) }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement(Icon__default['default'], __assign({ className: styles$3.validationStatusIcon, name: validationStatusIconProps.name, color: validationStatusIconProps.color, spin: validationStatusIconProps.spin, type: "solid", size: 12 }, ((metadata === null || metadata === void 0 ? void 0 : metadata.testId) && {
            metadata: {
                testId: (metadata === null || metadata === void 0 ? void 0 : metadata.testId) + "-icon",
            },
        }))),
        React__default['default'].createElement(Typography__default['default'], { className: styles$3.validationMessage, variant: "body-1", component: "span" }, message)));
};

var Validations = function (_a) {
    var className = _a.className, validations = _a.validations;
    return (React__default['default'].createElement("div", { className: classnames__default['default'](styles$4.validations, className) }, validations && validations.length && (React__default['default'].createElement(React__default['default'].Fragment, null, validations.map(function (validation) { return (React__default['default'].createElement(ValidationMessage, { key: validation.message, className: styles$4.validation, message: validation.message, status: validation.status, metadata: { testId: 'form-field-validation' } })); })))));
};

var HorizontalFormField = function (_a) {
    var className = _a.className, children = _a.children, label = _a.label, htmlFor = _a.htmlFor, labelTooltipContent = _a.labelTooltipContent, labelTooltipMouseOutDelay = _a.labelTooltipMouseOutDelay, helperText = _a.helperText, hintText = _a.hintText, metadata = _a.metadata, validations = _a.validations;
    var tooltipText = (helperText || labelTooltipContent) && (React__default['default'].createElement(React__default['default'].Fragment, null,
        helperText && (React__default['default'].createElement(Typography__default['default'], { variant: "body-1", className: styles$6.tooltipContent }, helperText)),
        helperText && labelTooltipContent && React__default['default'].createElement("br", null),
        labelTooltipContent && (React__default['default'].createElement(Typography__default['default'], { variant: "body-1", className: styles$6.tooltipContent }, labelTooltipContent))));
    return (React__default['default'].createElement("div", __assign({ className: classnames__default['default'](styles$6.horizontalFormField, className) }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement("div", { className: styles$6.head },
            React__default['default'].createElement(Label, __assign({ label: label, tooltipContent: tooltipText, tooltipClassName: styles$6.tooltipIcon, tooltipMouseOutDelay: labelTooltipMouseOutDelay }, (htmlFor ? { htmlFor: htmlFor } : {}))),
            hintText && React__default['default'].createElement(Typography__default['default'], { variant: "caption-2" }, hintText)),
        React__default['default'].createElement("div", { className: styles$6.field }, children),
        React__default['default'].createElement(Validations, { validations: validations, className: styles$6.validations })));
};

var styles$2 = {"helperText":"styles-module__1LD0vyji__v1-0-3","hintText":"styles-module__W4yW_FJQ__v1-0-3"};

var HelperText = function (_a) {
    var className = _a.className, text = _a.text, hintText = _a.hintText;
    return (React__default['default'].createElement("span", { className: className },
        React__default['default'].createElement(Typography__default['default'], { className: styles$2.helperText, variant: "body-1", component: "span" }, text),
        hintText && (React__default['default'].createElement(Typography__default['default'], { className: styles$2.hintText, variant: "body-1", component: "span" },
            "(",
            hintText,
            ")"))));
};

var styles$1 = {"formField":"FormField-module__2g2WiHLE__v1-0-3","childrenWrapper":"FormField-module__Pa6k6PwC__v1-0-3"};

var VerticalFormField = function (_a) {
    var className = _a.className, children = _a.children, label = _a.label, htmlFor = _a.htmlFor, labelTooltipContent = _a.labelTooltipContent, labelTooltipMouseOutDelay = _a.labelTooltipMouseOutDelay, helperText = _a.helperText, hintText = _a.hintText, metadata = _a.metadata, validations = _a.validations;
    return (React__default['default'].createElement("div", __assign({ className: classnames__default['default'](styles$1.formField, className) }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement(Label, __assign({ className: styles$1.childrenWrapper, label: label, tooltipContent: labelTooltipContent, tooltipMouseOutDelay: labelTooltipMouseOutDelay }, (htmlFor ? { htmlFor: htmlFor } : {}))),
        helperText && (React__default['default'].createElement(HelperText, { className: styles$1.childrenWrapper, text: helperText, hintText: hintText })),
        React__default['default'].createElement("div", { className: styles$1.childrenWrapper }, children),
        React__default['default'].createElement(Validations, { validations: validations })));
};

var FormField = function (_a) {
    var horizontal = _a.horizontal, rest = __rest(_a, ["horizontal"]);
    return horizontal ? (React__default['default'].createElement(HorizontalFormField, __assign({}, rest))) : (React__default['default'].createElement(VerticalFormField, __assign({}, rest)));
};

var styles = {"label":"FormFieldView-module__1tixnD10__v1-0-3","placeholder":"FormFieldView-module__2T4qUb0S__v1-0-3"};

var FormFieldView = function (_a) {
    var _b;
    var _c = _a.children, children = _c === void 0 ? null : _c, _d = _a.className, className = _d === void 0 ? '' : _d, _e = _a.metadata, metadata = _e === void 0 ? {} : _e, _f = _a.placeholder, placeholder = _f === void 0 ? '-' : _f, label = _a.label;
    return (React__default['default'].createElement("div", __assign({ className: className }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement(Typography__default['default'], { variant: "subtitle-2", component: "div", className: styles.label }, label),
        React__default['default'].createElement(Typography__default['default'], { variant: "subtitle-3", component: "div", className: classnames__default['default']((_b = {},
                _b[styles.placeholder] = !children,
                _b)) }, children || placeholder)));
};

exports.FormField = FormField;
exports.FormFieldView = FormFieldView;
//# sourceMappingURL=index.js.map
