import React from 'react';
import { PropsWithMetadata } from '@highlight-ui/utils-commons';
import { LabelProps } from '../label';
import { HelperTextProps } from '../helper-text';
import { ValidationMessageProps } from '../validations/validation-message';
export declare type VerticalFormFieldProps = PropsWithMetadata<{
    className?: string;
    children: React.ReactNode;
    label: LabelProps['label'];
    htmlFor?: LabelProps['htmlFor'];
    labelTooltipContent?: LabelProps['tooltipContent'];
    labelTooltipMouseOutDelay?: LabelProps['tooltipMouseOutDelay'];
    helperText?: HelperTextProps['text'];
    hintText?: HelperTextProps['hintText'];
    validations?: Array<Omit<ValidationMessageProps, 'className'>>;
}>;
declare const VerticalFormField: ({ className, children, label, htmlFor, labelTooltipContent, labelTooltipMouseOutDelay, helperText, hintText, metadata, validations, }: VerticalFormFieldProps) => JSX.Element;
export default VerticalFormField;
